<?php

namespace Liberty\Services\Emisor\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for conductor StructType
 * @subpackage Structs
 */
class Conductor extends AbstractStructBase
{
    /**
     * The apellidoMatConductor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $apellidoMatConductor;
    /**
     * The apellidoPatConductor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $apellidoPatConductor;
    /**
     * The fechaNacimientoConductor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $fechaNacimientoConductor;
    /**
     * The nombresConductor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $nombresConductor;
    /**
     * The rutConductor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $rutConductor;
    /**
     * The rutDvConductor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rutDvConductor;
    /**
     * Constructor method for conductor
     * @uses Conductor::setApellidoMatConductor()
     * @uses Conductor::setApellidoPatConductor()
     * @uses Conductor::setFechaNacimientoConductor()
     * @uses Conductor::setNombresConductor()
     * @uses Conductor::setRutConductor()
     * @uses Conductor::setRutDvConductor()
     * @param string $apellidoMatConductor
     * @param string $apellidoPatConductor
     * @param int $fechaNacimientoConductor
     * @param string $nombresConductor
     * @param int $rutConductor
     * @param string $rutDvConductor
     */
    public function __construct($apellidoMatConductor = null, $apellidoPatConductor = null, $fechaNacimientoConductor = null, $nombresConductor = null, $rutConductor = null, $rutDvConductor = null)
    {
        $this
            ->setApellidoMatConductor($apellidoMatConductor)
            ->setApellidoPatConductor($apellidoPatConductor)
            ->setFechaNacimientoConductor($fechaNacimientoConductor)
            ->setNombresConductor($nombresConductor)
            ->setRutConductor($rutConductor)
            ->setRutDvConductor($rutDvConductor);
    }
    /**
     * Get apellidoMatConductor value
     * @return string|null
     */
    public function getApellidoMatConductor()
    {
        return $this->apellidoMatConductor;
    }
    /**
     * Set apellidoMatConductor value
     * @param string $apellidoMatConductor
     * @return \Liberty\Services\Emisor\StructType\Conductor
     */
    public function setApellidoMatConductor($apellidoMatConductor = null)
    {
        // validation for constraint: string
        if (!is_null($apellidoMatConductor) && !is_string($apellidoMatConductor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($apellidoMatConductor)), __LINE__);
        }
        $this->apellidoMatConductor = $apellidoMatConductor;
        return $this;
    }
    /**
     * Get apellidoPatConductor value
     * @return string|null
     */
    public function getApellidoPatConductor()
    {
        return $this->apellidoPatConductor;
    }
    /**
     * Set apellidoPatConductor value
     * @param string $apellidoPatConductor
     * @return \Liberty\Services\Emisor\StructType\Conductor
     */
    public function setApellidoPatConductor($apellidoPatConductor = null)
    {
        // validation for constraint: string
        if (!is_null($apellidoPatConductor) && !is_string($apellidoPatConductor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($apellidoPatConductor)), __LINE__);
        }
        $this->apellidoPatConductor = $apellidoPatConductor;
        return $this;
    }
    /**
     * Get fechaNacimientoConductor value
     * @return int|null
     */
    public function getFechaNacimientoConductor()
    {
        return $this->fechaNacimientoConductor;
    }
    /**
     * Set fechaNacimientoConductor value
     * @param int $fechaNacimientoConductor
     * @return \Liberty\Services\Emisor\StructType\Conductor
     */
    public function setFechaNacimientoConductor($fechaNacimientoConductor = null)
    {
        // validation for constraint: int
        if (!is_null($fechaNacimientoConductor) && !is_numeric($fechaNacimientoConductor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($fechaNacimientoConductor)), __LINE__);
        }
        $this->fechaNacimientoConductor = $fechaNacimientoConductor;
        return $this;
    }
    /**
     * Get nombresConductor value
     * @return string|null
     */
    public function getNombresConductor()
    {
        return $this->nombresConductor;
    }
    /**
     * Set nombresConductor value
     * @param string $nombresConductor
     * @return \Liberty\Services\Emisor\StructType\Conductor
     */
    public function setNombresConductor($nombresConductor = null)
    {
        // validation for constraint: string
        if (!is_null($nombresConductor) && !is_string($nombresConductor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($nombresConductor)), __LINE__);
        }
        $this->nombresConductor = $nombresConductor;
        return $this;
    }
    /**
     * Get rutConductor value
     * @return int|null
     */
    public function getRutConductor()
    {
        return $this->rutConductor;
    }
    /**
     * Set rutConductor value
     * @param int $rutConductor
     * @return \Liberty\Services\Emisor\StructType\Conductor
     */
    public function setRutConductor($rutConductor = null)
    {
        // validation for constraint: int
        if (!is_null($rutConductor) && !is_numeric($rutConductor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($rutConductor)), __LINE__);
        }
        $this->rutConductor = $rutConductor;
        return $this;
    }
    /**
     * Get rutDvConductor value
     * @return string|null
     */
    public function getRutDvConductor()
    {
        return $this->rutDvConductor;
    }
    /**
     * Set rutDvConductor value
     * @param string $rutDvConductor
     * @return \Liberty\Services\Emisor\StructType\Conductor
     */
    public function setRutDvConductor($rutDvConductor = null)
    {
        // validation for constraint: string
        if (!is_null($rutDvConductor) && !is_string($rutDvConductor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rutDvConductor)), __LINE__);
        }
        $this->rutDvConductor = $rutDvConductor;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Liberty\Services\Emisor\StructType\Conductor
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
