<?php

namespace Liberty\Services\Emisor\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tipoEmision StructType
 * @subpackage Structs
 */
class TipoEmision extends AbstractStructBase
{
    /**
     * The codigoTipoEmision
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $codigoTipoEmision;
    /**
     * The continuidadRiesgo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Liberty\Services\Emisor\StructType\Continuidad
     */
    public $continuidadRiesgo;
    /**
     * The factura
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Liberty\Services\Emisor\StructType\Factura
     */
    public $factura;
    /**
     * The guia
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Liberty\Services\Emisor\StructType\Guia
     */
    public $guia;
    /**
     * The inspeccion
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Liberty\Services\Emisor\StructType\Inspeccion
     */
    public $inspeccion;
    /**
     * Constructor method for tipoEmision
     * @uses TipoEmision::setCodigoTipoEmision()
     * @uses TipoEmision::setContinuidadRiesgo()
     * @uses TipoEmision::setFactura()
     * @uses TipoEmision::setGuia()
     * @uses TipoEmision::setInspeccion()
     * @param int $codigoTipoEmision
     * @param \Liberty\Services\Emisor\StructType\Continuidad $continuidadRiesgo
     * @param \Liberty\Services\Emisor\StructType\Factura $factura
     * @param \Liberty\Services\Emisor\StructType\Guia $guia
     * @param \Liberty\Services\Emisor\StructType\Inspeccion $inspeccion
     */
    public function __construct($codigoTipoEmision = null, \Liberty\Services\Emisor\StructType\Continuidad $continuidadRiesgo = null, \Liberty\Services\Emisor\StructType\Factura $factura = null, \Liberty\Services\Emisor\StructType\Guia $guia = null, \Liberty\Services\Emisor\StructType\Inspeccion $inspeccion = null)
    {
        $this
            ->setCodigoTipoEmision($codigoTipoEmision)
            ->setContinuidadRiesgo($continuidadRiesgo)
            ->setFactura($factura)
            ->setGuia($guia)
            ->setInspeccion($inspeccion);
    }
    /**
     * Get codigoTipoEmision value
     * @return int|null
     */
    public function getCodigoTipoEmision()
    {
        return $this->codigoTipoEmision;
    }
    /**
     * Set codigoTipoEmision value
     * @param int $codigoTipoEmision
     * @return \Liberty\Services\Emisor\StructType\TipoEmision
     */
    public function setCodigoTipoEmision($codigoTipoEmision = null)
    {
        // validation for constraint: int
        if (!is_null($codigoTipoEmision) && !is_numeric($codigoTipoEmision)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($codigoTipoEmision)), __LINE__);
        }
        $this->codigoTipoEmision = $codigoTipoEmision;
        return $this;
    }
    /**
     * Get continuidadRiesgo value
     * @return \Liberty\Services\Emisor\StructType\Continuidad|null
     */
    public function getContinuidadRiesgo()
    {
        return $this->continuidadRiesgo;
    }
    /**
     * Set continuidadRiesgo value
     * @param \Liberty\Services\Emisor\StructType\Continuidad $continuidadRiesgo
     * @return \Liberty\Services\Emisor\StructType\TipoEmision
     */
    public function setContinuidadRiesgo(\Liberty\Services\Emisor\StructType\Continuidad $continuidadRiesgo = null)
    {
        $this->continuidadRiesgo = $continuidadRiesgo;
        return $this;
    }
    /**
     * Get factura value
     * @return \Liberty\Services\Emisor\StructType\Factura|null
     */
    public function getFactura()
    {
        return $this->factura;
    }
    /**
     * Set factura value
     * @param \Liberty\Services\Emisor\StructType\Factura $factura
     * @return \Liberty\Services\Emisor\StructType\TipoEmision
     */
    public function setFactura(\Liberty\Services\Emisor\StructType\Factura $factura = null)
    {
        $this->factura = $factura;
        return $this;
    }
    /**
     * Get guia value
     * @return \Liberty\Services\Emisor\StructType\Guia|null
     */
    public function getGuia()
    {
        return $this->guia;
    }
    /**
     * Set guia value
     * @param \Liberty\Services\Emisor\StructType\Guia $guia
     * @return \Liberty\Services\Emisor\StructType\TipoEmision
     */
    public function setGuia(\Liberty\Services\Emisor\StructType\Guia $guia = null)
    {
        $this->guia = $guia;
        return $this;
    }
    /**
     * Get inspeccion value
     * @return \Liberty\Services\Emisor\StructType\Inspeccion|null
     */
    public function getInspeccion()
    {
        return $this->inspeccion;
    }
    /**
     * Set inspeccion value
     * @param \Liberty\Services\Emisor\StructType\Inspeccion $inspeccion
     * @return \Liberty\Services\Emisor\StructType\TipoEmision
     */
    public function setInspeccion(\Liberty\Services\Emisor\StructType\Inspeccion $inspeccion = null)
    {
        $this->inspeccion = $inspeccion;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Liberty\Services\Emisor\StructType\TipoEmision
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
